/* DO NOT EDIT THIS FILE. It was created by extractDecls */
/*
 * See file ../COPYRIGHT for copying and redistribution conditions.
 *
 * This header-file specifies the API for the module that contains sever-side
 * functions that are common to both version 5 and version 6 of the FEEDME
 * and NOTIFYME messages.
 */

#ifndef FORN_H
#define FORN_H

#include "ldm.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
 * Determines if a subscription has been reduced and logs a message if it has.
 *
 * @param origSub   [in] Original subscription
 * @param currSub   [in] Current subscription
 * @param entity    [in] Entity that reduced the subscription. Replaces the
 *                  blank in the sentence "Subscription reduced by one or more
 *                  _____".
 * @retval 0        If and only if the original subscription equals the
 *                  current subscription (i.e., the subscription has not been
 *                  reduced)
 */
int logIfReduced(
        const prod_class_t* const   origSub,
        const prod_class_t* const   currSub,
        const char*                 entity);

#ifdef __cplusplus
}
#endif

#endif
